<?php

	$nzshpcrt_gateways[$num]['name'] = 'iDEAL';
	$nzshpcrt_gateways[$num]['internalname'] = 'LDB_ideal';
	$nzshpcrt_gateways[$num]['function'] = 'gateway_LDB_ideal';
	$nzshpcrt_gateways[$num]['form'] = "form_LDB_ideal";
	$nzshpcrt_gateways[$num]['submit_function'] = "submit_LDB_ideal";
	$nzshpcrt_gateways[$num]['payment_type'] = "credit_card";
	
	function LDB_appendHash($hashString)
	{
		/*
			Create a proper iDEAL verification hash
		*/
		$hashString = str_replace(array(" - ", " ", "\t", "\n", "&amp;", "&lt;", "&gt;", "&quote;"), array("", "", "", "", "&", "<", ">", "\""), $hashString);
	    $hash = sha1($hashString);
	    return $hash;
	}
	
	function gateway_LDB_ideal($seperator, $sessionid)
	{
		/*
			Set up the form which transfers the data to iDEAL.
		*/
		global $wpdb;
		$purchase_log_sql = 'SELECT * FROM ' . WPSC_TABLE_PURCHASE_LOGS . ' WHERE sessionid=' . $sessionid . ' LIMIT 1';
		$purchase_log = $wpdb->get_results($purchase_log_sql, ARRAY_A) ;
		$amount = nzshpcrt_overall_total_price($_SESSION['delivery_country']);
		$validUntil = date('Y-m-d\TH:i:s.000\Z', strtotime ('+1 week'));
		$phpamount = intval(round($amount*100));
		$paymenttype = 'ideal';
		$hash = LDB_appendHash(get_option('ldb_ideal_key') . ' - ' . get_option('ldb_ideal_id') . ' - ' . '0' . ' - ' . $phpamount . ' - ' . $purchase_log[0]['id'] . ' - ' . $paymenttype . ' - ' . $validUntil . ' - ' . '1' . ' - ' . 'Total' . ' - ' . '1'. ' - ' . $phpamount);
	?>
	<body>
	<form method="post" action="<?php echo get_option('ideal_url');?>" id="ideal_form" name="ideal_form">
	<input type="hidden" NAME="merchantID" value="<?php echo get_option('ideal_id');?>" />
	<input type="hidden" name="subID" value="0">
	<input type="hidden" NAME="purchaseID" value="<?php echo $purchase_log[0]['id'];?>" />
	<input type="hidden" NAME="description" value="Order <?php echo $purchase_log[0]['id'];?>" />
	<input type="hidden" NAME="amount" value="<?php echo $phpamount; ?>" />
	<input type="hidden" NAME="validUntil" value="<?php echo $validUntil; ?>" />
	<input type="hidden" name="currency" value="<?php echo get_option('ideal_currency');?>" />
	<input type="hidden" name="language" value="<?php echo get_option('ideal_language');?>" />
	<input type="hidden" name="urlSuccess" value="<?php echo get_option('ideal_urlSuccess');?>">
	<input type="hidden" name="urlCancel" value="<?php echo get_option('ideal_urlCancel');?>">
	<input type="hidden" name="urlError" value="<?php echo get_option('ideal_urlError');?>">
	<input type="hidden" name="paymentType" value="<?php echo $paymenttype; ?>">
	<input type="hidden" name="itemNumber1" value="1">
	<input type="hidden" name="itemDescription1" value="Total">
	<input type="hidden" name="itemQuantity1" value="1">
	<input type="hidden" name="itemPrice1" value="<?php echo $phpamount; ?>">
	<input type="hidden" name="hash" value="<?php echo $hash; ?>">
	</form>
	<script type="text/javascript">
		document.ideal_form.submit();
	</script>
	</body>
	<?php
		die();
		exit();
	}
	
	function submit_LDB_ideal()
	{
		/*
			Save the posted variables
		*/
		if($_POST['ldb_ideal_id'] != null) {
			update_option('ldb_ideal_id', $_POST['ldb_ideal_id']);
		}
		if($_POST['ldb_ideal_urlSuccess'] != null) {
			update_option('ldb_ideal_urlSuccess', $_POST['ldb_ideal_urlSuccess']);
		}
		if($_POST['ldb_ideal_urlCancel'] != null) {
			update_option('ldb_ideal_urlCancel', $_POST['ldb_ideal_urlCancel']);
		}
		if($_POST['ldb_ideal_urlError'] != null) {
			update_option('ldb_ideal_urlError', $_POST['ldb_ideal_urlError']);
		}
		if($_POST['ldb_ideal_url'] != null) {
			update_option('ldb_ideal_url', $_POST['ldb_ideal_url']);
		}
		if($_POST['ldb_ideal_key'] != null) {
			update_option('ldb_ideal_key', $_POST['ldb_ideal_key']);
		}
		if($_POST['ldb_ideal_currency'] != null) {
			update_option('ldb_ideal_currency', $_POST['ldb_ideal_currency']);
		}
		if($_POST['ldb_ideal_language'] != null) {
			update_option('ldb_ideal_language', $_POST['ldb_ideal_language']);
		}
		return true;
	}
	
	function form_LDB_ideal()
	{
		/*
			Set up the variables
		*/
		$language1 = '';
		$language2 = '';
		$language3 = '';
		$currency1 = '';
		$currency2 = '';
		$currency3 = '';

		/*
			Determine selected options
		*/
		if (get_option('ldb_ideal_language') == 'en_US'){
			$language1 = 'selected="selected" ';
		} else if (get_option('ldb_ideal_language') == 'nl_NL') {
			$language2 = 'selected="selected" ';
		} else if (get_option('ldb_ideal_language') == 'fr_FR') {
			$language3 = 'selected="selected" ';
		}
		
		if (get_option('ldb_ideal_currency') == 'EUR'){
			$currency1 = 'selected="selected" ';
		} else if(get_option('ldb_ideal_currency') == 'USD') {
			$currency2 = 'selected="selected" ';
		} else if(get_option('ldb_ideal_currency') == 'GBP') {
			$currency3 = 'selected="selected" ';
		}
		
		/*
			Create the form
		*/
		$output = '
		<tr>
			<td>
				iDEAL MerchantID <a href="#" title="Your iDEAL ID number, also named AcceptantID." style="text-decoration: none;">*</a>
			</td>
			<td>
				<input type="text" size="20" value="' . get_option('ldb_ideal_id') . '" name="ldb_ideal_id" />
			</td>
		</tr>
		<tr>
			<td>
				iDEAL MerchantKey <a href="#" title="Also named Hash Key or \'Geheime sleutel\', generated and defined in \'Configuratie\' in your online iDEAL Dashboard. (Hash Key for testing has to differ from the key used for production)" style="text-decoration: none;">*</a>
			</td>
			<td>
				<input type="text" size="20" value="' . get_option('ldb_ideal_key') . '" name="ldb_ideal_key" />
			</td>
		</tr>
		<tr>
			<td>
				iDEAL URL <a href="#" title="The address of your account\'s iDEAL site. Most banks require a test sequence before going live which can be done through the test URLs." style="text-decoration: none;">*</a>
			</td>
			<td>
				<input type="text" size="20" value="' . get_option('ldb_ideal_url') . '" name="ldb_ideal_url" />
			</td>
		</tr>
		<tr>
			<td>
				iDEAL urlSuccess <a href="#" title="The URL iDEAL should return your customer to after a successful payment, it would be wise to include `?wpsc_ajax_action=empty_cart` at the end of the URL to automatically empty the shopping cart." style="text-decoration: none;">*</a>
			</td>
			<td>
				<input type="text" size="20" value="' .  get_option('ldb_ideal_urlSuccess') . '" name="ldb_ideal_urlSuccess" />
			</td>
		</tr>
		<tr>
			<td>
				iDEAL urlCancel <a href="#" title="The URL iDEAL should return your customer to after a cancelled payment." style="text-decoration: none;">*</a>
			</td>
			<td>
				<input type="text" size="20" value="' .  get_option('ldb_ideal_urlCancel') . '" name="ldb_ideal_urlCancel" />
			</td>
		</tr>
		<tr>
			<td>
				iDEAL urlError <a href="#" title="The URL iDEAL should return your customer to after a failed payment." style="text-decoration: none;">*</a>
			</td>
			<td>
				<input type="text" size="20" value="' .  get_option('ldb_ideal_urlError') . '" name="ldb_ideal_urlError" />
			</td>
		</tr>
		<tr>
			<td>
				iDEAL Currency <a href="#" title="The currency used for your iDEAL transactions." style="text-decoration: none;">*</a>
			</td>
			<td>
				<select value="' . get_option('ldb_ideal_currency') . '" name="ldb_ideal_currency">
					<option ' . $currency1 . 'value="EUR">EUR</option>
					<option ' . $currency2 . 'value="USD">USD</option>
					<option ' . $currency3 . 'value="GBP">GBP</option>
				</select>
			</td>
		</tr>
		<tr>
			<td>
				iDEAL Language <a href="#" title="The language version of iDEAL your customers should be directed to." style="text-decoration: none;">*</a>
			</td>
			<td>
				<select value="' . get_option('ldb_ideal_language') . '" name="ldb_ideal_language">
					<option ' . $language1 . 'value="en_US">English</option>
					<option ' . $language2 . 'value="nl_NL">Dutch</option>
					<option ' . $language3 . 'value="fr_FR">Français</option>
				</select>
			</td>
		</tr>
		<tr>
			<td colspan="2">
				<h2>Message from the developer</h2>
				<p>I\'ve spend quite some time developing the LDB WP e-Commerce iDEAL plugin and plan to continue doing so. If you use this plugin please <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=MYF3W8N6QWXCJ">donate</a> a token of your appreciation!</p><p style="text-align: center;"><a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=MYF3W8N6QWXCJ"><img src="/wp-content/plugins/ldb-wp-e-commerce-ideal/donate.gif" alt="Donate" style="border: 0;" /></a></p>
			</td>
		</tr>';

		return $output;
	}
?>